#include "matrice.h"
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

mymatrix * creer (int n, int m)
{
	int i, j ;
	mymatrix * tmp = malloc(sizeof(mymatrix)) ;
	tmp->n = n ;
	tmp->m = m ;
	// allocation de la matrice
	tmp->M = malloc(n*sizeof(float *)) ;
	for (i=0; i<n; i++)
		(tmp->M)[i] = malloc(m*sizeof(float)) ;
	// initialisation à 0
	for (i=0; i<n; i++)
	{
		for (j=0; j<m; j++)
			(tmp->M)[i][j] = 0 ;
	}
	return tmp ;
}

void detruire (mymatrix *A)
{
	int i ;
	for (i=0; i<(A->n); i++)
	{
		free ((A->M)[i]);
	}
	free (A->M) ;
}

void somme (mymatrix *A, mymatrix *B, mymatrix *C)
{
	int i, j ;
	assert((A->n == B->n) && (A->n == C->n)) ;
	assert((A->m == B->m) && (A->m == B->m)) ;
	
	for (i=0; i < A->n; i++)
	{
		for (j=0; j < A->m;  j++)
			(C->M)[i][j] = (A->M)[i][j]+(B->M)[i][j] ;
	}
}

void prod (mymatrix *A, mymatrix *B, mymatrix *C)
{
	int i, j, k ;
	assert(A->m == B->n) ;
	assert(C->n == A->n) ;
	assert(C->m == B->m) ;
	mymatrix *tmp = creer(A->n,B->m) ;
	
	for (i=0; i < A->n; i++)
	{
		for (j=0; j < B->m;  j++)
		{
			(tmp->M)[i][j] = 0 ;
			for (k=0 ; k < A->m ; k++)
				(tmp->M)[i][j] = (tmp->M)[i][j] + (A->M)[i][k]*(B->M)[k][j] ;
		}
	}
	for (i=0; i < C->n; i++)
	{
		for (j=0; j < C->m;  j++)
			(C->M)[i][j] = (tmp->M)[i][j] ;
	}
}

void point (float l, mymatrix *A, mymatrix *C)
{
	int i, j ;
	assert(A->n == C->n) ;
	assert(A->m == C->m) ;

	for (i=0; i < A->n; i++)
	{
		for (j=0; j < A->m;  j++)
			(C->M)[i][j] = l*(A->M)[i][j] ;
	}
}

void print_matrix(mymatrix *A)
{
	int i, j ;
	
	for (i=0; i<A->n; i++)
	{
		for (j=0; j<A->m; j++)
			printf("%f\t", (A->M)[i][j]) ;
		printf("\n") ;
	}
}
